# coding: utf-8

"""
    Google Slides API

    Reads and writes Google Slides presentations.

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from google_slides_ti.models.response import Response
from google_slides_ti.models.write_control import WriteControl
from typing import Optional, Set
from typing_extensions import Self

class BatchUpdatePresentationResponse(BaseModel):
    """
    Response message from a batch update.
    """ # noqa: E501
    presentation_id: Optional[StrictStr] = Field(default=None, description="The presentation the updates were applied to.", alias="presentationId")
    replies: Optional[List[Response]] = Field(default=None, description="The reply of the updates. This maps 1:1 with the updates, although replies to some requests may be empty.")
    write_control: Optional[WriteControl] = Field(default=None, alias="writeControl")
    __properties: ClassVar[List[str]] = ["presentationId", "replies", "writeControl"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of BatchUpdatePresentationResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in replies (list)
        _items = []
        if self.replies:
            for _item_replies in self.replies:
                if _item_replies:
                    _items.append(_item_replies.to_dict())
            _dict['replies'] = _items
        # override the default output from pydantic by calling `to_dict()` of write_control
        if self.write_control:
            _dict['writeControl'] = self.write_control.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of BatchUpdatePresentationResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "presentationId": obj.get("presentationId"),
            "replies": [Response.from_dict(_item) for _item in obj["replies"]] if obj.get("replies") is not None else None,
            "writeControl": WriteControl.from_dict(obj["writeControl"]) if obj.get("writeControl") is not None else None
        })
        return _obj


