# coding: utf-8

"""
    Google Slides API

    Reads and writes Google Slides presentations.

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from google_slides_ti.models.text_style import TextStyle
from typing import Optional, Set
from typing_extensions import Self

class Bullet(BaseModel):
    """
    Describes the bullet of a paragraph.
    """ # noqa: E501
    bullet_style: Optional[TextStyle] = Field(default=None, alias="bulletStyle")
    glyph: Optional[StrictStr] = Field(default=None, description="The rendered bullet glyph for this paragraph.")
    list_id: Optional[StrictStr] = Field(default=None, description="The ID of the list this paragraph belongs to.", alias="listId")
    nesting_level: Optional[StrictInt] = Field(default=None, description="The nesting level of this paragraph in the list.", alias="nestingLevel")
    __properties: ClassVar[List[str]] = ["bulletStyle", "glyph", "listId", "nestingLevel"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Bullet from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of bullet_style
        if self.bullet_style:
            _dict['bulletStyle'] = self.bullet_style.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Bullet from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "bulletStyle": TextStyle.from_dict(obj["bulletStyle"]) if obj.get("bulletStyle") is not None else None,
            "glyph": obj.get("glyph"),
            "listId": obj.get("listId"),
            "nestingLevel": obj.get("nestingLevel")
        })
        return _obj


