# coding: utf-8

"""
    Google Slides API

    Reads and writes Google Slides presentations.

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from google_slides_ti.models.line_properties import LineProperties
from typing import Optional, Set
from typing_extensions import Self

class Line(BaseModel):
    """
    A PageElement kind representing a non-connector line, straight connector, curved connector, or bent connector.
    """ # noqa: E501
    line_category: Optional[StrictStr] = Field(default=None, description="The category of the line. It matches the `category` specified in CreateLineRequest, and can be updated with UpdateLineCategoryRequest.", alias="lineCategory")
    line_properties: Optional[LineProperties] = Field(default=None, alias="lineProperties")
    line_type: Optional[StrictStr] = Field(default=None, description="The type of the line.", alias="lineType")
    __properties: ClassVar[List[str]] = ["lineCategory", "lineProperties", "lineType"]

    @field_validator('line_category')
    def line_category_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['LINE_CATEGORY_UNSPECIFIED', 'STRAIGHT', 'BENT', 'CURVED']):
            raise ValueError("must be one of enum values ('LINE_CATEGORY_UNSPECIFIED', 'STRAIGHT', 'BENT', 'CURVED')")
        return value

    @field_validator('line_type')
    def line_type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['TYPE_UNSPECIFIED', 'STRAIGHT_CONNECTOR_1', 'BENT_CONNECTOR_2', 'BENT_CONNECTOR_3', 'BENT_CONNECTOR_4', 'BENT_CONNECTOR_5', 'CURVED_CONNECTOR_2', 'CURVED_CONNECTOR_3', 'CURVED_CONNECTOR_4', 'CURVED_CONNECTOR_5', 'STRAIGHT_LINE']):
            raise ValueError("must be one of enum values ('TYPE_UNSPECIFIED', 'STRAIGHT_CONNECTOR_1', 'BENT_CONNECTOR_2', 'BENT_CONNECTOR_3', 'BENT_CONNECTOR_4', 'BENT_CONNECTOR_5', 'CURVED_CONNECTOR_2', 'CURVED_CONNECTOR_3', 'CURVED_CONNECTOR_4', 'CURVED_CONNECTOR_5', 'STRAIGHT_LINE')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Line from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of line_properties
        if self.line_properties:
            _dict['lineProperties'] = self.line_properties.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Line from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "lineCategory": obj.get("lineCategory"),
            "lineProperties": LineProperties.from_dict(obj["lineProperties"]) if obj.get("lineProperties") is not None else None,
            "lineType": obj.get("lineType")
        })
        return _obj


