# coding: utf-8

"""
    Google Slides API

    Reads and writes Google Slides presentations.

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class Link(BaseModel):
    """
    A hypertext link.
    """ # noqa: E501
    page_object_id: Optional[StrictStr] = Field(default=None, description="If set, indicates this is a link to the specific page in this presentation with this ID. A page with this ID may not exist.", alias="pageObjectId")
    relative_link: Optional[StrictStr] = Field(default=None, description="If set, indicates this is a link to a slide in this presentation, addressed by its position.", alias="relativeLink")
    slide_index: Optional[StrictInt] = Field(default=None, description="If set, indicates this is a link to the slide at this zero-based index in the presentation. There may not be a slide at this index.", alias="slideIndex")
    url: Optional[StrictStr] = Field(default=None, description="If set, indicates this is a link to the external web page at this URL.")
    __properties: ClassVar[List[str]] = ["pageObjectId", "relativeLink", "slideIndex", "url"]

    @field_validator('relative_link')
    def relative_link_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['RELATIVE_SLIDE_LINK_UNSPECIFIED', 'NEXT_SLIDE', 'PREVIOUS_SLIDE', 'FIRST_SLIDE', 'LAST_SLIDE']):
            raise ValueError("must be one of enum values ('RELATIVE_SLIDE_LINK_UNSPECIFIED', 'NEXT_SLIDE', 'PREVIOUS_SLIDE', 'FIRST_SLIDE', 'LAST_SLIDE')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Link from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Link from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "pageObjectId": obj.get("pageObjectId"),
            "relativeLink": obj.get("relativeLink"),
            "slideIndex": obj.get("slideIndex"),
            "url": obj.get("url")
        })
        return _obj


