# coding: utf-8

"""
    Google Slides API

    Reads and writes Google Slides presentations.

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from google_slides_ti.models.rgb_color import RgbColor
from typing import Optional, Set
from typing_extensions import Self

class OpaqueColor(BaseModel):
    """
    A themeable solid color value.
    """ # noqa: E501
    rgb_color: Optional[RgbColor] = Field(default=None, alias="rgbColor")
    theme_color: Optional[StrictStr] = Field(default=None, description="An opaque theme color.", alias="themeColor")
    __properties: ClassVar[List[str]] = ["rgbColor", "themeColor"]

    @field_validator('theme_color')
    def theme_color_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['THEME_COLOR_TYPE_UNSPECIFIED', 'DARK1', 'LIGHT1', 'DARK2', 'LIGHT2', 'ACCENT1', 'ACCENT2', 'ACCENT3', 'ACCENT4', 'ACCENT5', 'ACCENT6', 'HYPERLINK', 'FOLLOWED_HYPERLINK', 'TEXT1', 'BACKGROUND1', 'TEXT2', 'BACKGROUND2']):
            raise ValueError("must be one of enum values ('THEME_COLOR_TYPE_UNSPECIFIED', 'DARK1', 'LIGHT1', 'DARK2', 'LIGHT2', 'ACCENT1', 'ACCENT2', 'ACCENT3', 'ACCENT4', 'ACCENT5', 'ACCENT6', 'HYPERLINK', 'FOLLOWED_HYPERLINK', 'TEXT1', 'BACKGROUND1', 'TEXT2', 'BACKGROUND2')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of OpaqueColor from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of rgb_color
        if self.rgb_color:
            _dict['rgbColor'] = self.rgb_color.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of OpaqueColor from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "rgbColor": RgbColor.from_dict(obj["rgbColor"]) if obj.get("rgbColor") is not None else None,
            "themeColor": obj.get("themeColor")
        })
        return _obj


