# coding: utf-8

"""
    Google Slides API

    Reads and writes Google Slides presentations.

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional
from google_slides_ti.models.color_scheme import ColorScheme
from google_slides_ti.models.page_background_fill import PageBackgroundFill
from typing import Optional, Set
from typing_extensions import Self

class PageProperties(BaseModel):
    """
    The properties of the Page. The page will inherit properties from the parent page. Depending on the page type the hierarchy is defined in either SlideProperties or LayoutProperties.
    """ # noqa: E501
    color_scheme: Optional[ColorScheme] = Field(default=None, alias="colorScheme")
    page_background_fill: Optional[PageBackgroundFill] = Field(default=None, alias="pageBackgroundFill")
    __properties: ClassVar[List[str]] = ["colorScheme", "pageBackgroundFill"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of PageProperties from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of color_scheme
        if self.color_scheme:
            _dict['colorScheme'] = self.color_scheme.to_dict()
        # override the default output from pydantic by calling `to_dict()` of page_background_fill
        if self.page_background_fill:
            _dict['pageBackgroundFill'] = self.page_background_fill.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of PageProperties from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "colorScheme": ColorScheme.from_dict(obj["colorScheme"]) if obj.get("colorScheme") is not None else None,
            "pageBackgroundFill": PageBackgroundFill.from_dict(obj["pageBackgroundFill"]) if obj.get("pageBackgroundFill") is not None else None
        })
        return _obj


