# coding: utf-8

"""
    Google Slides API

    Reads and writes Google Slides presentations.

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class Placeholder(BaseModel):
    """
    The placeholder information that uniquely identifies a placeholder shape.
    """ # noqa: E501
    index: Optional[StrictInt] = Field(default=None, description="The index of the placeholder. If the same placeholder types are present in the same page, they would have different index values.")
    parent_object_id: Optional[StrictStr] = Field(default=None, description="The object ID of this shape's parent placeholder. If unset, the parent placeholder shape does not exist, so the shape does not inherit properties from any other shape.", alias="parentObjectId")
    type: Optional[StrictStr] = Field(default=None, description="The type of the placeholder.")
    __properties: ClassVar[List[str]] = ["index", "parentObjectId", "type"]

    @field_validator('type')
    def type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['NONE', 'BODY', 'CHART', 'CLIP_ART', 'CENTERED_TITLE', 'DIAGRAM', 'DATE_AND_TIME', 'FOOTER', 'HEADER', 'MEDIA', 'OBJECT', 'PICTURE', 'SLIDE_NUMBER', 'SUBTITLE', 'TABLE', 'TITLE', 'SLIDE_IMAGE']):
            raise ValueError("must be one of enum values ('NONE', 'BODY', 'CHART', 'CLIP_ART', 'CENTERED_TITLE', 'DIAGRAM', 'DATE_AND_TIME', 'FOOTER', 'HEADER', 'MEDIA', 'OBJECT', 'PICTURE', 'SLIDE_NUMBER', 'SUBTITLE', 'TABLE', 'TITLE', 'SLIDE_IMAGE')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Placeholder from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Placeholder from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "index": obj.get("index"),
            "parentObjectId": obj.get("parentObjectId"),
            "type": obj.get("type")
        })
        return _obj


