# coding: utf-8

"""
    Google Slides API

    Reads and writes Google Slides presentations.

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from google_slides_ti.models.substring_match_criteria import SubstringMatchCriteria
from typing import Optional, Set
from typing_extensions import Self

class ReplaceAllTextRequest(BaseModel):
    """
    Replaces all instances of text matching a criteria with replace text.
    """ # noqa: E501
    contains_text: Optional[SubstringMatchCriteria] = Field(default=None, alias="containsText")
    page_object_ids: Optional[List[StrictStr]] = Field(default=None, description="If non-empty, limits the matches to page elements only on the given pages. Returns a 400 bad request error if given the page object ID of a notes master, or if a page with that object ID doesn't exist in the presentation.", alias="pageObjectIds")
    replace_text: Optional[StrictStr] = Field(default=None, description="The text that will replace the matched text.", alias="replaceText")
    __properties: ClassVar[List[str]] = ["containsText", "pageObjectIds", "replaceText"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ReplaceAllTextRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of contains_text
        if self.contains_text:
            _dict['containsText'] = self.contains_text.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ReplaceAllTextRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "containsText": SubstringMatchCriteria.from_dict(obj["containsText"]) if obj.get("containsText") is not None else None,
            "pageObjectIds": obj.get("pageObjectIds"),
            "replaceText": obj.get("replaceText")
        })
        return _obj


