# coding: utf-8

"""
    Google Slides API

    Reads and writes Google Slides presentations.

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional
from google_slides_ti.models.table_border_cell import TableBorderCell
from typing import Optional, Set
from typing_extensions import Self

class TableBorderRow(BaseModel):
    """
    Contents of each border row in a table.
    """ # noqa: E501
    table_border_cells: Optional[List[TableBorderCell]] = Field(default=None, description="Properties of each border cell. When a border's adjacent table cells are merged, it is not included in the response.", alias="tableBorderCells")
    __properties: ClassVar[List[str]] = ["tableBorderCells"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of TableBorderRow from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in table_border_cells (list)
        _items = []
        if self.table_border_cells:
            for _item_table_border_cells in self.table_border_cells:
                if _item_table_border_cells:
                    _items.append(_item_table_border_cells.to_dict())
            _dict['tableBorderCells'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of TableBorderRow from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "tableBorderCells": [TableBorderCell.from_dict(_item) for _item in obj["tableBorderCells"]] if obj.get("tableBorderCells") is not None else None
        })
        return _obj


