# coding: utf-8

"""
    Google Slides API

    Reads and writes Google Slides presentations.

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt
from typing import Any, ClassVar, Dict, List, Optional
from google_slides_ti.models.table_cell_location import TableCellLocation
from google_slides_ti.models.table_cell_properties import TableCellProperties
from google_slides_ti.models.text_content import TextContent
from typing import Optional, Set
from typing_extensions import Self

class TableCell(BaseModel):
    """
    Properties and contents of each table cell.
    """ # noqa: E501
    column_span: Optional[StrictInt] = Field(default=None, description="Column span of the cell.", alias="columnSpan")
    location: Optional[TableCellLocation] = None
    row_span: Optional[StrictInt] = Field(default=None, description="Row span of the cell.", alias="rowSpan")
    table_cell_properties: Optional[TableCellProperties] = Field(default=None, alias="tableCellProperties")
    text: Optional[TextContent] = None
    __properties: ClassVar[List[str]] = ["columnSpan", "location", "rowSpan", "tableCellProperties", "text"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of TableCell from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of location
        if self.location:
            _dict['location'] = self.location.to_dict()
        # override the default output from pydantic by calling `to_dict()` of table_cell_properties
        if self.table_cell_properties:
            _dict['tableCellProperties'] = self.table_cell_properties.to_dict()
        # override the default output from pydantic by calling `to_dict()` of text
        if self.text:
            _dict['text'] = self.text.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of TableCell from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "columnSpan": obj.get("columnSpan"),
            "location": TableCellLocation.from_dict(obj["location"]) if obj.get("location") is not None else None,
            "rowSpan": obj.get("rowSpan"),
            "tableCellProperties": TableCellProperties.from_dict(obj["tableCellProperties"]) if obj.get("tableCellProperties") is not None else None,
            "text": TextContent.from_dict(obj["text"]) if obj.get("text") is not None else None
        })
        return _obj


