# coding: utf-8

"""
    Google Slides API

    Reads and writes Google Slides presentations.

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional
from google_slides_ti.models.dimension import Dimension
from google_slides_ti.models.table_cell import TableCell
from google_slides_ti.models.table_row_properties import TableRowProperties
from typing import Optional, Set
from typing_extensions import Self

class TableRow(BaseModel):
    """
    Properties and contents of each row in a table.
    """ # noqa: E501
    row_height: Optional[Dimension] = Field(default=None, alias="rowHeight")
    table_cells: Optional[List[TableCell]] = Field(default=None, description="Properties and contents of each cell. Cells that span multiple columns are represented only once with a column_span greater than 1. As a result, the length of this collection does not always match the number of columns of the entire table.", alias="tableCells")
    table_row_properties: Optional[TableRowProperties] = Field(default=None, alias="tableRowProperties")
    __properties: ClassVar[List[str]] = ["rowHeight", "tableCells", "tableRowProperties"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of TableRow from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of row_height
        if self.row_height:
            _dict['rowHeight'] = self.row_height.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in table_cells (list)
        _items = []
        if self.table_cells:
            for _item_table_cells in self.table_cells:
                if _item_table_cells:
                    _items.append(_item_table_cells.to_dict())
            _dict['tableCells'] = _items
        # override the default output from pydantic by calling `to_dict()` of table_row_properties
        if self.table_row_properties:
            _dict['tableRowProperties'] = self.table_row_properties.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of TableRow from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "rowHeight": Dimension.from_dict(obj["rowHeight"]) if obj.get("rowHeight") is not None else None,
            "tableCells": [TableCell.from_dict(_item) for _item in obj["tableCells"]] if obj.get("tableCells") is not None else None,
            "tableRowProperties": TableRowProperties.from_dict(obj["tableRowProperties"]) if obj.get("tableRowProperties") is not None else None
        })
        return _obj


