# coding: utf-8

"""
    Google Slides API

    Reads and writes Google Slides presentations.

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from google_slides_ti.models.table_border_properties import TableBorderProperties
from google_slides_ti.models.table_range import TableRange
from typing import Optional, Set
from typing_extensions import Self

class UpdateTableBorderPropertiesRequest(BaseModel):
    """
    Updates the properties of the table borders in a Table.
    """ # noqa: E501
    border_position: Optional[StrictStr] = Field(default=None, description="The border position in the table range the updates should apply to. If a border position is not specified, the updates will apply to all borders in the table range.", alias="borderPosition")
    fields: Optional[StrictStr] = Field(default=None, description="The fields that should be updated. At least one field must be specified. The root `tableBorderProperties` is implied and should not be specified. A single `\"*\"` can be used as short-hand for listing every field. For example to update the table border solid fill color, set `fields` to `\"tableBorderFill.solidFill.color\"`. To reset a property to its default value, include its field name in the field mask but leave the field itself unset.")
    object_id: Optional[StrictStr] = Field(default=None, description="The object ID of the table.", alias="objectId")
    table_border_properties: Optional[TableBorderProperties] = Field(default=None, alias="tableBorderProperties")
    table_range: Optional[TableRange] = Field(default=None, alias="tableRange")
    __properties: ClassVar[List[str]] = ["borderPosition", "fields", "objectId", "tableBorderProperties", "tableRange"]

    @field_validator('border_position')
    def border_position_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['ALL', 'BOTTOM', 'INNER', 'INNER_HORIZONTAL', 'INNER_VERTICAL', 'LEFT', 'OUTER', 'RIGHT', 'TOP']):
            raise ValueError("must be one of enum values ('ALL', 'BOTTOM', 'INNER', 'INNER_HORIZONTAL', 'INNER_VERTICAL', 'LEFT', 'OUTER', 'RIGHT', 'TOP')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of UpdateTableBorderPropertiesRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of table_border_properties
        if self.table_border_properties:
            _dict['tableBorderProperties'] = self.table_border_properties.to_dict()
        # override the default output from pydantic by calling `to_dict()` of table_range
        if self.table_range:
            _dict['tableRange'] = self.table_range.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of UpdateTableBorderPropertiesRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "borderPosition": obj.get("borderPosition"),
            "fields": obj.get("fields"),
            "objectId": obj.get("objectId"),
            "tableBorderProperties": TableBorderProperties.from_dict(obj["tableBorderProperties"]) if obj.get("tableBorderProperties") is not None else None,
            "tableRange": TableRange.from_dict(obj["tableRange"]) if obj.get("tableRange") is not None else None
        })
        return _obj


