# coding: utf-8

"""
    Google Slides API

    Reads and writes Google Slides presentations.

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from google_slides_ti.models.table_row_properties import TableRowProperties
from typing import Optional, Set
from typing_extensions import Self

class UpdateTableRowPropertiesRequest(BaseModel):
    """
    Updates the properties of a Table row.
    """ # noqa: E501
    fields: Optional[StrictStr] = Field(default=None, description="The fields that should be updated. At least one field must be specified. The root `tableRowProperties` is implied and should not be specified. A single `\"*\"` can be used as short-hand for listing every field. For example to update the minimum row height, set `fields` to `\"min_row_height\"`. If '\"min_row_height\"' is included in the field mask but the property is left unset, the minimum row height will default to 0.")
    object_id: Optional[StrictStr] = Field(default=None, description="The object ID of the table.", alias="objectId")
    row_indices: Optional[List[StrictInt]] = Field(default=None, description="The list of zero-based indices specifying which rows to update. If no indices are provided, all rows in the table will be updated.", alias="rowIndices")
    table_row_properties: Optional[TableRowProperties] = Field(default=None, alias="tableRowProperties")
    __properties: ClassVar[List[str]] = ["fields", "objectId", "rowIndices", "tableRowProperties"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of UpdateTableRowPropertiesRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of table_row_properties
        if self.table_row_properties:
            _dict['tableRowProperties'] = self.table_row_properties.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of UpdateTableRowPropertiesRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "fields": obj.get("fields"),
            "objectId": obj.get("objectId"),
            "rowIndices": obj.get("rowIndices"),
            "tableRowProperties": TableRowProperties.from_dict(obj["tableRowProperties"]) if obj.get("tableRowProperties") is not None else None
        })
        return _obj


