# coding: utf-8

"""
    Google Slides API

    Reads and writes Google Slides presentations.

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from google_slides_ti.models.video_properties import VideoProperties
from typing import Optional, Set
from typing_extensions import Self

class Video(BaseModel):
    """
    A PageElement kind representing a video.
    """ # noqa: E501
    id: Optional[StrictStr] = Field(default=None, description="The video source's unique identifier for this video.")
    source: Optional[StrictStr] = Field(default=None, description="The video source.")
    url: Optional[StrictStr] = Field(default=None, description="An URL to a video. The URL is valid as long as the source video exists and sharing settings do not change.")
    video_properties: Optional[VideoProperties] = Field(default=None, alias="videoProperties")
    __properties: ClassVar[List[str]] = ["id", "source", "url", "videoProperties"]

    @field_validator('source')
    def source_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['SOURCE_UNSPECIFIED', 'YOUTUBE', 'DRIVE']):
            raise ValueError("must be one of enum values ('SOURCE_UNSPECIFIED', 'YOUTUBE', 'DRIVE')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Video from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of video_properties
        if self.video_properties:
            _dict['videoProperties'] = self.video_properties.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Video from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "source": obj.get("source"),
            "url": obj.get("url"),
            "videoProperties": VideoProperties.from_dict(obj["videoProperties"]) if obj.get("videoProperties") is not None else None
        })
        return _obj


